//THIS FILE IS AUTOGENERATED
//DO NOT MODIFY
import { Schema } from 'mongoose';
import { BaseDocument } from '@core/api/BaseDocument';
import { ModelSchema } from '@core/orm/schema/ModelSchema';

export interface PatientBaseDocument extends BaseDocument {
    firstname: string;
    lastname: string;
    description?: string;
    address?: { street?: string; houseNumber?: number; city?: string; country?: string; zip?: string };
    gender: 'male' | 'female' | 'diverse';
    email?: string;
    phone?: string;
}

export const PatientBaseSchema: ModelSchema = new ModelSchema({
    firstname: {
        type: String,
        required: true,
        immutable: false,
        unique: false,
        select: true,
        array: false,
        writable: true,
        readable: true,
        defaultColumn: false,
        listed: true,
        maxLength: 255,
    },
    lastname: {
        type: String,
        required: true,
        immutable: false,
        unique: false,
        select: true,
        array: false,
        writable: true,
        readable: true,
        defaultColumn: false,
        listed: true,
        maxLength: 255,
    },
    description: {
        type: String,
        required: false,
        immutable: false,
        unique: false,
        select: true,
        array: false,
        writable: true,
        readable: true,
        defaultColumn: false,
        listed: true,
        maxLength: 10000,
    },
    address: {
        street: {
            type: String,
            required: false,
            immutable: false,
            unique: false,
            select: true,
            array: false,
            writable: true,
            readable: true,
            defaultColumn: false,
            listed: true,
            maxLength: 255,
        },
        houseNumber: {
            type: Number,
            required: function () {
                return (this.firstname === null && this.lastname != false) || this.address.street === 'user';
            },
            immutable: false,
            unique: false,
            select: true,
            array: false,
            writable: true,
            readable: true,
            defaultColumn: false,
            listed: true,
            maxLength: 10,
        },
        city: {
            type: String,
            required: false,
            immutable: false,
            unique: false,
            select: true,
            array: false,
            writable: true,
            readable: true,
            defaultColumn: false,
            listed: true,
            minLength: 3,
            maxLength: 255,
        },
        country: {
            type: String,
            required: false,
            immutable: false,
            unique: false,
            select: true,
            array: false,
            writable: true,
            readable: true,
            defaultColumn: false,
            listed: true,
            minLength: 3,
            maxLength: 255,
        },
        zip: {
            type: String,
            required: false,
            immutable: false,
            unique: false,
            select: true,
            array: false,
            writable: true,
            readable: true,
            defaultColumn: false,
            listed: true,
            maxLength: 6,
        },
    },
    gender: {
        type: String,
        required: true,
        immutable: false,
        unique: false,
        select: true,
        default: 'diverse',
        enum: ['male', 'female', 'diverse'],
        array: false,
        writable: true,
        readable: true,
        defaultColumn: false,
        listed: true,
    },
    email: {
        type: String,
        required: false,
        immutable: false,
        unique: false,
        select: true,
        array: false,
        writable: true,
        readable: true,
        defaultColumn: false,
        listed: true,
    },
    phone: {
        type: String,
        required: false,
        immutable: false,
        unique: false,
        select: true,
        array: false,
        writable: true,
        readable: true,
        defaultColumn: false,
        listed: true,
    },
});

PatientBaseSchema.methods.getDisplayName = function () {
    return this.firstname + ' ' + this.lastname;
};

PatientBaseSchema.statics.conditions = {
    required: {
        'address.houseNumber': [
            [
                { property: 'firstname', operator: '=', value: null },
                { property: 'lastname', operator: '!=', value: false },
            ],
            [{ property: 'address.street', operator: '=', value: 'user' }],
        ],
    },
    disabled: {},
    validate: {},
};
